# Just tests to see how the assembler handles various code patterns

.syntax unified	
.arm
#.thumb
	
# Syscalls
.equ SYSCALL_EXIT,     1


        .globl _start
_start:	

@        add r1,r2,r2,LSL #4
	
@	ldrb r1, [r2]   @ register
@	ldrb  r1, [r2,#20] @ register/offset
@	ldrb  r1, [r2,+r3]  @ register + register
@	ldrb  r1, [r2,-r3]  @ register - register	
@	ldrb  r1, [r2,r3, LSL #2]  @ register +/- register, shift
	
@	ldrb  r1, [r2, #20]! @ pre-index.  Load from r2+20 then write back
@	ldrb  r1, [r2, r3]! @ pre-index.  Load from r2+20 then write back
@	ldrb  r1, [r2, r3, LSL #4]! @ pre-index.  Load from r2+20 then write back
	
@	ldrb  r1, [r2],#+1   @ post-index.  load, then add value to r2
@	ldrb  r1, [r2],r3    @ post-index
@	ldrb  r1, [r2],r3, LSL #4 @ post-index
	
@	cmp   r1, #5
@	addeq r2,r2,#2
@	subne r3,r3,#2
@	addeqs r2,r2,#2
	
@	adds r2,r2,#2

	bl	routine
	
        #================================
        # Exit
        #================================
exit:
	mov	r0,#5
	add	r8,r9,r10
	mov	r7,#SYSCALL_EXIT	@ put exit syscall number (1) in eax
	swi	0x0			@ and exit


routine:

	adds    r3,#1
	add	r3,#1

wide_vs_narrow:	
@	adds.w	r3,#1
@	adds.n	r3,#1
	
three_arguments:	
	add	r1,r2,r3
	
	it ge
	addge %r1,%r2
	
	itete cc
	addcc %r1,%r2
	addcs %r1,%r2
	addcc %r1,%r2
	addcs %r1,%r2
	
	it	ne
	addne	r0,r0,r1
	
	blx	lr
	